operation QPE(Upower : (Int, Qubit[]) => Unit is Adj + Ctl,
           qsclock : Qubit[], qstarget : Qubit[]) : Unit is Adj {
    body (...) {     //Original operation
        let n = Length(qsclock);
        MultiH(qsclock);
        for i in 0 .. n - 1 {
            Controlled Upower([qsclock[n - i - 1]], (2 ^ i, qstarget)); 
        }
        Adjoint QFT(qsclock);
    }
    adjoint auto;  //Generate adjoint version of QPE by Q#.
}