operation TeleportQubit(qsrc : Qubit, qanc : Qubit, qdest : Qubit) : Unit {
    H(qanc);
    CNOT(qanc, qdest);
    CNOT(qsrc, qanc);
    H(qsrc);
    let m2 = M(qanc);
    if (m2 == One) { X(qdest); }
    let m1 = M(qsrc);
    if (m1 == One) { Z(qdest); }
}