operation Random_0to2() : Int {
    use qs = Qubit[2];
    mutable m = 0;
    repeat {
        ResetAll(qs);
        H(qs[0]);
        H(qs[1]);     //Generate uniform superposition state
        set m = ResultArrayAsInt(MultiM(qs));
    } until (m < 3);    //Success condition
    ResetAll(qs);
    return m;
}